library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.numeric_std.ALL;

entity DPRegister is
    Port ( clka : in std_logic;
           cea : in std_logic;
           da : in std_logic;
           clkb : in std_logic;
           ceb : in std_logic;
           db : in std_logic;
           q : out std_logic);
end DPRegister;

architecture RTL of DPRegister is

component FD is
    Port ( C, CE, D : in std_logic;
           Q : out std_logic);
end component;


signal d1, d2, q1, q2: std_logic;

begin

d1 <= da xor q2;
ff1: FD port map (C => clka, CE => cea, D => d1, Q => q1);

d2 <= db xor q1;
ff2: FD port map (C => clkb, CE => ceb, D => d2, Q => q2);

q <= q1 xor q2;

end RTL;
