library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.numeric_std.ALL;

entity Debouncer is
    Port ( clk : in std_logic;
           key : in std_logic;
           q : out std_logic);
end Debouncer;

architecture RTL of Debouncer is

signal ctr: unsigned(1 downto 0);
signal max: boolean;

begin

max <= ctr = "11";

process (clk, key)
begin
    if key = '0' then
        ctr <= (others => '0');
    elsif rising_edge(clk) then
        if max then
            q <= '1';
        else
            q <= '0';
            ctr <= ctr + 1;
        end if;
    end if;
end process;


end RTL;
